;-------------------------------------------------------------------------------
;print.asm
;(c) Copyright 2000-2001, Ilya Aniskovets
;-------------------------------------------------------------------------------
section .text
;-------------------------------------------------------------------------------
print_init:
	ld hl,print_rst_address
	ld (#5c51),hl
	ld a,#04
	ld (#5c48),a
	ld (#5c8d),a
	ret
;-------------------------------------------------------------------------------
print_rst10:
	ld (.i2+1),hl
	pop hl
	ld (.i1+1),hl
	pop hl
	ld (.i3+1),hl
	pop hl
	push af
	call print_string
	pop af
	push hl
.i3:	ld hl,#0000
	push hl
.i2:	ld hl,#0000
.i1:	jp #0000
;-------------------------------------------------------------------------------
print_string:
	ld a,(hl)
        inc hl
        dec a
        jr nz,.next
        push de
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ex de,hl
        call print_string
        pop hl
        pop de
        jr print_string
.next:	inc a
	ret z
	call print_char
	jr print_string
;-------------------------------------------------------------------------------
print_char:
	push ix
	push hl
	push de
	push bc
	push af
	cp #0d
	jr z,.enter
	call print_symbol
	ld hl,print_coordx
	ld a,(hl)
	sub #3f
	jr nz,.d1
.d0:	ld (hl),a
	inc hl
.d1:	inc (hl)
	ld a,(print_coordy)
	cp #18
	jr nz,.d2
	dec (hl)
	call #0dfe
.d2:	ld a,(print_coordx)
	or a
	call z,print_scroll
	pop af
	pop bc
	pop de
	pop hl
	pop ix
	ret
.enter:
	ld hl,print_coordx
	xor a
	jr .d0
;-------------------------------------------------------------------------------
print_coords	equ $+1
print_coordx	equ $+1
print_coordy	equ $+2
;-------------------------------------------------------------------------------
print_getpos:
	ld hl,#0000
.hl:   	srl l
	push af
	ld a,h
times 3	rrca
	and #e0
	add a,l
	ld l,a
	ld a,h
	and #18
	or #40
	ld h,a
	pop af
	ret
;-------------------------------------------------------------------------------
print_symbol:
	srl a
	ld l,a
	ld b,#08
	sbc a,a
	xor #f0
	ld c,a
	ld h,b
times 3	add hl,hl
	ld de,font-#4000
	add hl,de
	ex de,hl
	call print_getpos
	sbc a,a
	xor #f0
	cp c
	ld c,a
	jr nz,.lab2
.lab1:
	ld a,(de)
	xor (hl)
	and c
	xor (hl)
	ld (hl),a
	inc h
	inc de
	djnz .lab1
	ret
.lab2:
	ld a,(de)
times 4	rrca
	xor (hl)
	and c
	xor (hl)
	ld (hl),a
	inc h
	inc de
	djnz .lab2
	ret
;-------------------------------------------------------------------------------
print_scroll:
	ld a,0
	inc a
	ld (print_scroll+1),a
	cp #17
	ret nz
	jr keys
keys
	push ix
	push hl
	push de
	push bc
	xor a
	ld (print_scroll+1),a
	call invertc
	ei
.no	bit 5,(iy+1)
	jr z,.no
	res 5,(iy+1)
	ld a,(#5c08)
	ex af,af'
	call invertc
	ld hl,#001e
	ld d,h
	ld e,l
	call #3b5
	ex af,af'
	pop bc
	pop de
	pop hl
	pop ix
	ret
invertc	ld hl,(print_coords)
invert	call print_getpos.hl
	sbc a,a
	xor #f0
	ld c,a
	ld b,#08
.lp1
	ld a,(hl)
	xor c
	ld (hl),a
	inc h
	djnz .lp1
	ret
;-------------------------------------------------------------------------------
print_cls:
	ld hl,#4000
	ld de,#4001
	ld bc,#1800
	ld (hl),l
	ldir
	ld bc,#2ff
	ld (hl),#04
	ldir
	ld (print_coords),bc
	ret
;-------------------------------------------------------------------------------
section .data
;-------------------------------------------------------------------------------
font:	incbin "data\font.c"
;-------------------------------------------------------------------------------
print_rst_address: dw print_rst10
;-------------------------------------------------------------------------------
